/*
 * SegunValoresParejaDeCamposIguales.java
 *
 * Created on 29 de mayo de 2007, 09:40 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.fidufosyga.rules;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.StringTokenizer;

/**
 * 
 * @author JSolano
 */
public class SegunValoresParejaDeCamposIguales extends AbstractRule {
	// COL?1 NOT IN(?2) AND @campo=COL?3 AND COL?4=COL?5 AND
	// DATALENGTH(@campo)>0
	// 11,'3'#'4',3,21,4
	// 23,14#15,14,31,15
	// 22,'3'#'4',14,31,15
	/** Creates a new instance of CampoVacio */
	public SegunValoresParejaDeCamposIguales() {
	}

	public void setParams(Object[] params) {
		String valores = (String) params[1];
		ArrayList<String> listaString = new ArrayList<String>();
		StringTokenizer st = new StringTokenizer(valores, ",");
		while (st.hasMoreTokens()) {
			listaString.add(st.nextToken());
		}
		String[] array = listaString.toArray(new String[listaString.size()]);
		Arrays.sort(array);
		params[1] = array;

		super.setParams(params);
	}

	public boolean performValidation(String field, String registro[],
			String nombreArchivo) {
		// 22,'3'#'4',14,31,15
		String campo = registro[new Integer((String) getParams()[0]).intValue()];
		String campo2 = registro[new Integer((String) getParams()[2])
				.intValue()];
		String campo3 = registro[new Integer((String) getParams()[3])
				.intValue()];
		String campo4 = registro[new Integer((String) getParams()[4])
				.intValue()];

		if (Arrays.binarySearch((String[]) getParams()[1], campo) < 0
				// if (("3" != campo || "4" != campo)
				&& field.equals(campo2) && campo3.equals(campo4)
				&& field.length() > 0) {
			return true;
		}

		return false;

	}

}
